
// [Program]: IX_compose_demo.java   
// [Purpose]: This program demonstrates the IX_compose API class. 
// [Author ]: The J Maker
// [Note   ]: All rights reserved

import java.awt.*;
import java.awt.event.*;
import java.awt.Image;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.io.FileOutputStream;
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

public class IX_compose_demo extends Frame 
   {
   // main()
   public static void main(String argv[])
      {
      if (argv.length != 2 && argv.length != 3)
         {
         System.out.println("Usage: java IX_compose_demo <input_image_1> <input_image_2> [output_image]");
         System.exit(-1);
         }
      else if (argv.length == 2)
         new IX_compose_demo(argv[0], argv[1], null);
      else
         new IX_compose_demo(argv[0], argv[1], argv[2]);
      }

   // constrcutor
   public IX_compose_demo(String infile1, String infile2, String outfile)
      {
      super("IX_compose API Demo");
      setLayout(new FlowLayout(FlowLayout.CENTER));
   
      // read input image 1
      Image imin1 = Toolkit.getDefaultToolkit().getImage(infile1);
      while (imin1.getWidth(this) < 0 || imin1.getHeight(this) < 0)
         {
         try
            {
            Thread.sleep(50);
            }
         catch(Exception e) {}
         }

      // put input image 1 in a canvas for display
      IXutil_imcanvas myinput1 = new IXutil_imcanvas(imin1);

     // read input image 2
      Image imin2 = Toolkit.getDefaultToolkit().getImage(infile2);
      while (imin2.getWidth(this) < 0 || imin2.getHeight(this) < 0)
         {
         try
            {
            Thread.sleep(50);
            }
         catch(Exception e) {}
         }

      // put input image 2 in a canvas for display
      IXutil_imcanvas myinput2 = new IXutil_imcanvas(imin2);

      // create an output IX_compose object for testing
      IX_compose myoutput = new IX_compose(imin1, imin2);
 
      // lay out input and output images in the panel
      add(myinput1);
      add(myinput2);
      add(myoutput);
      pack();     
      show();
      repaint();

      // save output to file if the optional output filename is provided
      if (outfile != null)
         {
         try
            {
            BufferedImage outImage = new BufferedImage(myoutput.getWidth(),
               myoutput.getHeight(), BufferedImage.TYPE_INT_RGB);         
            Graphics2D g2d = outImage.createGraphics();
            g2d.drawImage(myoutput.getOutputImage(), 0, 0, this);
            g2d.dispose();
            OutputStream os = new FileOutputStream(outfile);
            JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(os);
            encoder.encode(outImage);
            os.close();
            } 
         catch (IOException e) 
            {
            e.printStackTrace();
            }
         }
 



      // handle window closing event
      addWindowListener(new WindowAdapter() 
         {
         public void windowClosing(WindowEvent we)
            {
            dispose();
            System.exit(0);
            }
         });      
      }
   }
