
// [Program]: IX_convex_demo.java   
// [Purpose]: This program demonstrates the IX_convex API class. 
// [Author ]: The J Maker
// [Note   ]: All rights reserved

import java.awt.*;
import java.awt.event.*;
import java.awt.Image;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.io.FileOutputStream;
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

public class IX_convex_demo extends Frame 
   {
   // main()
   public static void main(String argv[])
      {
      if (argv.length != 1 && argv.length != 2)
         {
         System.out.println("Usage: java IX_convex_demo <input_image> [output_image]");
         System.exit(-1);
         }
      else if (argv.length == 1)
         new IX_convex_demo(argv[0], null);
      else
         new IX_convex_demo(argv[0], argv[1]);
      }

   // constrcutor
   public IX_convex_demo(String infile, String outfile)
      {
      super("IX_convex API Demo");
      setLayout(new FlowLayout(FlowLayout.CENTER));

      // read input image
      Image imin = Toolkit.getDefaultToolkit().getImage(infile);
      while (imin.getWidth(this) < 0 || imin.getHeight(this) < 0)
         {
         try
            {
            Thread.sleep(50);
            }
         catch(Exception e) {}
         }

      // put the input image in a canvas for display
      IXutil_imcanvas myinput = new IXutil_imcanvas(imin);

      // create an output IX_convex object for testing
      IX_convex myoutput = new IX_convex(imin, 50, 70, 50, 3.0f);
 
      // lay out input and output images in the panel
      add(myinput);
      add(myoutput);
      pack();     
      show();
      repaint();

      // save output to file if the optional output filename is provided
      if (outfile != null)
         {
         try
            {
            BufferedImage outImage = new BufferedImage(myoutput.getWidth(),
               myoutput.getHeight(), BufferedImage.TYPE_INT_RGB);         
            Graphics2D g2d = outImage.createGraphics();
            g2d.drawImage(myoutput.getOutputImage(), 0, 0, this);
            g2d.dispose();
            OutputStream os = new FileOutputStream(outfile);
            JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(os);
            encoder.encode(outImage);
            os.close();
            } 
         catch (IOException e) 
            {
            e.printStackTrace();
            }
         }

      // handle window closing event
      addWindowListener(new WindowAdapter() 
         {
         public void windowClosing(WindowEvent we)
            {
            dispose();
            System.exit(0);
            }
         });      
      }
   }
